var http      = require("http");
var fs        = require("fs");
var config    = require('./config.js');
var socketio  = require('socket.io');
var opencv    = require('opencv');
var path      = require('path');

var server = http.createServer();

server.on('request', function(request, response){

  var basename = path.basename(decodeURI(request.url)) || 'index.html';
  var file     = config.STATIC_DIR+'/'+basename;

  fs.exists(file, function(exists){
    var headers = {"Content-Type": path.extname[file]};

    if (exists) {
      var output = fs.readFileSync(file);
    }
    else {
      var output = fs.readFileSync(config.TEMPLATE_DIR+"/index.html", "utf-8");
    }

    response.writeHead(200, headers);
    response.end(output);
  });
});

server.listen(config.PORT, config.IP, function(){
});

var io     = socketio.listen(server);

io.sockets.on('connection', function(socket){
  socket.on('video-update', function(dataURL){
     var prefix = 'data:image/png;base64,';
     var bitmap = dataURL.replace(prefix,'');
     var buf    = new Buffer(dataURL.replace(prefix,''), 'base64');

     opencv.readImage(buf, function(err, im){
       im.detectObject('./node_modules/opencv/data/haarcascade_frontalface_alt.xml', {}, function(err, faces) {
         for (var i = 0, max=faces.length; i < max; i++) {
           var face = faces[i];
           im.ellipse(face.x + face.width / 2, face.y + face.height / 2, face.width / 2, face.height / 2);
         }

         io.emit('capture-send', { dataURL: prefix+im.toBuffer().toString('base64')});
       });
     });
  });
});
